/******************************************************************************
 *
 * bung 11  Martin Hess, MC2, 24.8.2001
 *
 ******************************************************************************
 */

#include "CB-TSU.h"

#define LED_gruen (*(volatile unsigned char*)(0x400040))
#define LED_rot (*(volatile unsigned char*)(0x400050))
#define Schalter (*(volatile unsigned char*)(0x400030))

void init(void); /* Initialisiert uC */  
void wait(int);  /* Warteschlaufe */
int speed(void); /* Geschwindigkeit */

int main (void)
{

init();
LED_gruen = 0x01; 
LED_rot = 0x00;
	do
		{
   	LED_gruen = LED_gruen * 2;
   	wait(speed());
   	if (LED_gruen == 128) 
   		{
   		LED_gruen = 0x01;
   		wait(speed());
   		}; /* of if */
		while((Schalter & 0x01) == 1); /* erster Schalter */
	LED_rot = 0x00;
	}
while(1);
} /* of main */ 

void init (void)
{
CBTSU_DispString(1,"**** Uebung 11  ****");
CBTSU_DispString(2,"Martin Hess");
CBTSU_DispString(3,"24.8.2001");
} /* of init */                     

void wait (int count)
{
int i;  
int j; 
for (i=0; i<count; i++)
	{                   
	for (j=0; j<count; j++);
	};	
} /* of wait */                       

int speed (void)
{
int value = 200; 
          
if ((Schalter & 0x20) == 0) value = value + 100;
if ((Schalter & 0x40) == 0) value = value + 200;
if ((Schalter & 0x80) == 0) value = value + 500;

/* Speedmarker */
switch (value)
	{
	case 200  :  LED_rot = 0xFF;
					break;
	case 300  :  LED_rot = 0x80;
					break;
	case 400  :  LED_rot = 0x40;
					break;
	case 500  :  LED_rot = 0x20;
					break;
	case 600  :  LED_rot = 0x10;
					break;
	case 700  :  LED_rot = 0x08;
					break;
	case 800  :  LED_rot = 0x04;
					break;
	case 900  :  LED_rot = 0x02;
					break;         
	case 1000 :  LED_rot = 0x01;
					break;
	} /* of switch */
return(value);
} /* of speed */